commit 9454cd51da9b38b974cff7c8b7125901f6403848
Author: Adam Jackson <ajax@redhat.com>
Date:   Mon Apr 4 14:39:36 2016 -0400

    xserver 1.18.3
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 082d5ea9a8f882c5ab7c30c481e2d9a5c5f11376
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Mar 21 09:53:17 2016 +0100

    xwayland: Pretend we support viewport in vidmode
    
    Some games (namely openttd) will raise an XError and fail with a
    BadValue if their request to XF86VidModeSetViewPort fails.
    
    Support only the default zoom and viewport, fail for everything else.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>
    (cherry picked from commit 44e1c97ca6fe992bbb6ef9ecb0b82a113adfa57e)

commit fcb89adb4a6cde585923e63d3c34df465aa78d1b
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Mar 17 14:39:45 2016 +0100

    xwayland: do not include frequency in mode name
    
    Some applications (e.g. using lwjgl) try to parse the output of the
    xrandr command and get confused with the mode name returned by Xwayland,
    because it contains "@[frequency]" (e.g. "1024x640@60.0Hz").
    
    Remove the @[frequency] part of the mode name to match what is found in
    usual mode names on regular X servers to please those applications.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94589
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Daniel Stone <daniels@collabora.com>
    (cherry picked from commit 6e3a6e30a6ac66942a0756a5d079993181f02e34)

commit b8f9fd83189bd5593793c1cfcbfedb5150d7c5a5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 24 17:34:23 2016 +0900

    xfree86/modes: Make sure the HW cursor is hidden when it should be
    
    When the HW cursor is hidden (e.g. because xf86CursorResetCursor
    triggers a switch from HW cursor to SW cursor), the driver isn't
    notified of this for disabled CRTCs. If the HW cursor was shown when the
    CRTC was disabled, it may still be displayed when the CRTC is enabled
    again.
    
    Prevent this by explicitly hiding the HW cursor again after setting a
    mode if it's currently supposed to be hidden.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94560
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    (cherry picked from commit 418fe365b45a143680d3b4143dc60f7cdc5a3507)

commit 1211d483d4581ee5ccbd50c654d30cf3318fe7c6
Author: Sonny Jiang <sonny.jiang@amd.com>
Date:   Mon Mar 28 16:36:50 2016 +0900

    DRI2: add Polaris PCI IDs
    
    Signed-off-by: Sonny Jiang <sonny.jiang@amd.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com> (Polaris10)
    Reviewed-by: Michel Dänzer <michel.daenzer@amd.com> (Polaris11)
    
    (Ported from Mesa commit f00c840578a70e479ffb99f6b64c73dc420179fa)
    
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    Reviewed-by: Alex Deucher <alexander.deucher@amd.com>
    (cherry picked from commit 1c90797565385426ad63bd2108085c8466695c0b)

commit 07ad2fde78f07e98caaf3e9b6b67af15359fefe4
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Mar 24 17:42:47 2016 +0900

    present: Only requeue for next MSC after flip failure
    
    This code was added to deal with the driver present hook failing, in
    which case we need to wait for the next MSC before executing the
    presentation.
    
    However, it could also take effect in cases where the driver incorrectly
    thinks the current MSC matches the target one (e.g. due to the kernel
    interface only supporting 32-bit MSC values), in which case it could
    result in the presentation getting requeued over and over.
    
    To prevent such issues, check specifically for the target MSC
    immediately following the current MSC.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94596
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 3b385105b2d19a1c55e9779ae88d775185eea231)

commit e8f785f82ec8d3a76ae377c7430b1945180cba00
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed Mar 23 14:42:08 2016 -0400

    vfb: Re-add LD_EXPORT_SYMBOLS_FLAG to LDFLAGS
    
    Accidentally removed, breaks Xvfb on cygwin.
    
    Reviewed-by: Yaakov Selkowitz <yselkowitz@users.sourceforge.net>
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 8ac0e05cc6c6e87b223ba7cb31d8856771c5d41a)

commit fb8ddcf1cb0f47257370c3d6a895a5a41bea8dc0
Author: Dave Airlie <airlied@redhat.com>
Date:   Wed Mar 16 10:45:54 2016 +1000

    glamor: swizzle RED to 0 for alpha textures
    
    I'm pretty sure Eric suspected this could cause a problem, and we
    couldn't find a test. Well loading feedly in firefox seems to trigger
    badness that this solves.
    
    bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94554
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>
    Tested-by: Timo Aaltonen <tjaalton@ubuntu.com>
    (cherry picked from commit a288cf58a0dc0f965a6f964c76bb86bb1989d797)

commit 1bffe77769a9dce623e4a587ed3895ba003c257b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Mar 13 13:54:01 2016 +0000

    Xext/vidmode: Reduce verbosity of GetModeLine debug messages
    
    In commit f175cf45aebcdda53f3ae49c0eaf27da1f194e92
    Author: Olivier Fourdan <ofourdan@redhat.com>
    Date:   Wed Feb 10 09:34:34 2016 +0100
    
        vidmode: move to a separate library of its own
    
    the verbosity of some old debug messages (which print the reply to every
    GetModeLine client request and others) was increased leading to lots of
    log spam. Downgrade the logging back to DebugF.
    
    [ajax: Fix a typo so it compiles.]
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94515
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    Cc: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 75eecf28ae3709181a51571132b0accd9cae316e)

commit 93d4224ccf3dee5a51815a66f76c905450419b50
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 11 16:38:52 2016 -0500

    xserver 1.18.2
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit d88f8ffeb7ec0304d793388be5b65a293505bc3b
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 11 13:50:32 2016 -0500

    vidmode: Remove stray vidmodeproc.h from EXTRA_DIST
    
    Was removed from the tree in:
    
        commit f175cf45aebcdda53f3ae49c0eaf27da1f194e92
        Author: Olivier Fourdan <ofourdan@redhat.com>
        Date:   Wed Feb 10 09:34:34 2016 +0100
    
            vidmode: move to a separate library of its own
    
    but not removed from the Makefile, which broke 'make dist'.
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 744c292ae49dd1f9d33b860d2b4f0ae27023809b)

commit 643359fb03c51244c9ed5f5efab4c84594259e8c
Author: Dave Airlie <airlied@gmail.com>
Date:   Tue Feb 9 16:54:22 2016 +1000

    present: fail flipping if we have any slave outputs
    
    Due to the way present currently works, we don't ever check with the
    secondary adapters if we can flip at all.
    
    We shouldn't flip if the secondary adapters are attached to the pixmap
    currently, however using the current check_flip callback isn't possible
    as it passes the Window to the driver (something we shouldn't be doing),
    so the slave driver can never get it's own screen ptr back.
    
    For now to fix the problem just block flips if we have any slaves
    configured. We can fix the ABI up later, but this fix can be backported
    to stable.
    
    Signed-off-by: Dave Airlie <airlied@redhat.com>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 47bc7fcaa567b0d9e2627b4a21b112e96f81725b)

commit 3e480c6f5168e7da1521bdcc15ed8b5b8762612d
Author: Adam Jackson <ajax@redhat.com>
Date:   Thu Jan 21 12:47:57 2016 -0500

    glx: Implement GLX_EXT_fbconfig_packed_float
    
    The tokens for this are already defined by GLX_ARB_fbconfig_float, which
    we already support, so just add the extension to the list and let the
    driver provide those configs if it wants.
    
    Reviewed-by: Eric Anholt <eric@anholt.net>
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit ef3005da3d5dc92b3ee5a0ee78164e739a3216dc)

commit b9f7edda0634955711870bb1389095525d4496e3
Author: Adam Jackson <ajax@redhat.com>
Date:   Mon May 18 13:00:02 2015 -0400

    glx: Implement GLX_EXT_stereo_tree
    
    This is correct as it is, but only because we know no DRI drivers
    implement stereo.
    
    v2: Use new ATTRIB macro
    
    Reviewed-by: James Jones <jajones@nvidia.com>
    Reviewed-by: Eric Anholt <eric@anholt.net>
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit d15cb654b6ba365dac9a62064e277adebde2fdab)

commit 2b3363418a425bf432b55927d8f8dd93c004c791
Author: Adam Jackson <ajax@redhat.com>
Date:   Thu Mar 3 16:50:02 2016 -0500

    glx: Add GLX_SCREEN to the GetDrawableAttributes response
    
    libglvnd would like to use this to map from drawable to screen, so it
    can know which driver to dispatch to. Refer to the spec proposal here:
    
    https://lists.freedesktop.org/archives/mesa-dev/2016-March/109543.html
    
    Reviewed-by: Eric Anholt <eric@anholt.net>
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit a18238877bbf9aab95843d849a6f434275e9cd6c)

commit 2541d765fdd1006d649063882e3a667438f1d30e
Author: Adam Jackson <ajax@redhat.com>
Date:   Thu Mar 10 12:29:34 2016 -0500

    glx: Macroize building the attribute list in DoGetDrawableAttributes
    
    No functional change, just a little easier to read and harder to get
    wrong.
    
    Reviewed-by: Eric Anholt <eric@anholt.net>
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 47c1d6b7abcfb1c6b478367bbc2e869c91485bc0)

commit 2a7b6ea1a54a4c8174669c1ca38c4665505c4637
Author: Eric Anholt <eric@anholt.net>
Date:   Mon Feb 1 13:58:15 2016 -0800

    ephyr: Fix redisplay with glamor on GLES.
    
    glamor_transfer.c is still totally broken, though.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Eric Anholt <eric@anholt.net>
    (cherry picked from commit c01094c5312fbd84146dd83122e5256a8e57d092)

commit 5af20f15636aa2ede3dac1af9e9afa063564130c
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Mar 9 16:45:18 2016 +0100

    glamor: do not build Xv support when --disable-xv
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 25ce263fd88684be9370025f93ba3a2bfc72ff1a)

commit 9fc05b85e544638ccc4b811c19e64312b387c799
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Mar 9 16:21:18 2016 +0100

    xwayland: add glamor Xv adaptor
    
    This adds an Xv adaptor using glamor.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit da7724d3d277c6c8a814881785b716896802629a)

commit 1aa9a2be313c51a78af9bceea865dcf069e9cebe
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Mon Dec 21 17:54:08 2015 +0900

    modesetting: Allow CRTC transforms to actually take effect
    
    Setting crtc->transformPresent to FALSE was preventing the transform
    from actually taking effect and putting RandR into a confused state.
    
    Now that the RandR 1.2 cursor code handles transforms correctly, we can
    allow them to properly take effect.
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 24042b4e367803dd64f3fcdc1bef7b2bf36c4145)

commit aa8770bf546a58e534ad2d0e0180f7e1013e24e9
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Wed Oct 21 18:33:46 2015 +0900

    xfree86: Re-set current cursor after RandR 1.2 CRTC configuration change
    
    Add xf86CursorResetCursor, which allows switching between HW and SW
    cursor depending on the current state.
    
    Call it from xf86DisableUnusedFunctions, which is called after any CRTC
    configuration change such as setting a mode or disabling a CRTC. This
    makes sure that SW cursor is used e.g. while a transform is in use on
    any CRTC or while there are active PRIME output slaves, and enables HW
    cursor again once none of those conditions are true anymore.
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit b04767c84deafc44993723add4b1c5163fc11711)

commit 870d4e2e6b40f911049a5286d605814d2401741d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 24 12:56:03 2015 +0900

    xfree86/modes: Check for CRTC transforms in xf86_use_hw_cursor(_argb) (v2)
    
    We currently don't handle transforms for the HW cursor image, so return
    FALSE to signal a software cursor must be used if a transform is in use
    on any CRTC.
    
    v2: Check crtc->transformPresent instead of crtc->transform_in_use. The
        latter is TRUE for rotation as well, which we handle correctly.
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit a4ffa8721debb34bd36fd4624890d9c26886c618)

commit af87ab62878334ee9d4e75c472fc80178329b4dd
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Dec 24 16:20:49 2015 +0900

    xfree86/modes: Refactor xf86_use_hw_cursor_argb to use xf86_use_hw_cursor (v2)
    
    This reduces code duplication.
    
    v2: No functional change this time.
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit c3e4e9fc5d84bfc17b3ed63f67488ea25ba150ce)

commit 87c23dc47160d7524b82b60abbc70d285708f7cb
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 23 17:19:03 2016 +0900

    glamor: Source pictures are always depth 32
    
    We were using the destination pixmap depth to determine the source
    picture format.
    
    Fixes incorrect text rendering with some MATE desktop GTK3 themes.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94246
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    (cherry picked from commit a3e681eafa5355b8bb3b099d47983f14f0d5e197)

commit 0220275531552a5400c22b56105257586f390260
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Feb 23 17:19:02 2016 +0900

    glamor: Factor out glamor_set_color_depth from glamor_set_color
    
    The former takes explicit screen and depth parameters instead of
    deriving them from a pixmap.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Michel Dänzer <michel.daenzer@amd.com>
    (cherry picked from commit b05ae79ee3bebef9790c97eedc033d1ffb3ec39a)

commit 79985270f1d63a8b186640b81d0eb142ac532e6e
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Wed Feb 10 16:40:43 2016 +0100

    glamor: Fix XvPutImage when src_y != 0
    
    We already take src_y into account when uploading the src data by
    starting at the top line of the src data when uploading.
    
    Adjust src_y accordingly when rendering.
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>
    (cherry picked from commit 947e94a341fa153258e9e86060b83af95934672b)

commit ddca8e1647d3b79f803f4080be648e5475055fe8
Author: Rui Matos <tiagomatos@gmail.com>
Date:   Fri Mar 4 16:24:48 2016 +0100

    build: Enable vidmode independently from Xorg
    
    This allows building Xwayland without Xorg and still include the
    vidmode extension.
    
    v2: Use PKG_CHECK_EXISTS instead of PKG_CHECK_MODULES
    
    Signed-off-by: Rui Matos <tiagomatos@gmail.com>
    Reviewed-by: Emil Velikov <emil.l.velikov@gmail.com>
    (cherry picked from commit 40a164b8f4e720b0d6ebf228ee175eb397ffeec2)

commit 7680f558e1584a191554658ff7b3b75c75d35e06
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:34 2016 +0100

    xfixes: avoid double free if AddResource fails
    
    pChc is already freed through CursorFreeHideCount →
    deleteCursorHideCount.
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 2be527b1d4ce2b0412c4484539a8c9607645ec6d)

commit b7e1f25005f7b552870fe782fc927c9dc97f5ed0
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:33 2016 +0100

    render: free already allocated formats in PictureInit failure case
    
    Probably pointless, if this fails you're not likely to get far...
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 4217db89ecd480fda2ee74fecba06c6713c2a0f0)

commit 518a0c179f99e9ea33e9cd56ce215661d27cabb6
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:32 2016 +0100

    record: don't call RecordDeleteContext when AddResource fails
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 054f80717812d4781741cd05393623fe6f6c627f)

commit dae9c195a9db4d210855a16efce2037f3af454e1
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:31 2016 +0100

    xwin: no need to free auth data if AddResource fails
    
    This is taken care of by SecurityDeleteAuthorization
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit d0c1a5bc61a3d151f2234aa3820862f16c0f00c7)

commit 4bbaffc8134a72d4e2dd21d4def1afc9ad29e815
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:30 2016 +0100

    modesetting: avoid double free if AddResource fails
    
    ms_dri2_frame_event_client_gone or ms_dri2_frame_event_drawable_gone
    already free the resource.
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit acf263df81ad6813e0233033610fb44521cab1b4)

commit 8616bd95de43aa63c959b0c978f1001ac38c0222
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:29 2016 +0100

    dmx/glxProxy: don't free the glx pixmap twice if AddResource fails
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 164753f158e78f615f903467bfd234d7c58244ef)

commit dcbf88aea74a00a8e09ffdc4de2b555911eb90fb
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:28 2016 +0100

    glx: don't call pGlxDraw->destroy() if AddResource fails
    
    AddResource will have called DrawableGone, which takes care of the
    destruction.
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 59b9c3d5e4bf05aeaaac2ee4ea12c301a67aae2c)

commit ab197ee9478a0e4e7a276c03645657b4f22ae9c0
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Mar 7 23:20:26 2016 +0100

    xvmc: Fix unchecked AddResource
    
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 119d5c0e2f800737c949ef760c5fe25d963200bf)

commit bd022f03143723ac326b39d6e67853650aa1bf1d
Author: Jonas Ådahl <jadahl@gmail.com>
Date:   Tue Mar 8 20:05:33 2016 +0800

    xwayland: Correctly detect whether posix_fallocate exists
    
    We had HAVE_POSIX_FALLOCATE checks, but no such macros were ever
    defined anywhere. This commit makes it so that this macro is defined if
    the posix_fallocate is detected during configure.
    
    Signed-off-by: Jonas Ådahl <jadahl@gmail.com>
    Reviewed-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit a2c3c34b44b866440a152511e682c98879ee13b7)

commit 23d9b2a566cdaeff71deae9c3a221ebf0cb5f550
Author: Julien Cristau <jcristau@debian.org>
Date:   Tue Mar 1 21:39:01 2016 +0100

    xv: fix double free in AddResource failure case
    
    XvdiDestroyVideoNotifyList already frees the list if AddResource fails,
    so don't do it twice.  And set tpn->client to NULL explicitly to avoid
    confusing uninitialized memory with a valid value.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 939ce0bae68b682b57675f65c901653c1a094ebb)

commit 90b854b2acc58a9936e9810f58b0bd1973697210
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Mar 1 14:09:30 2016 -0500

    dri1: Fix unchecked AddResource
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    Reviewed-by: Julien Cristau <jcristau@debian.org>
    (cherry picked from commit 05e1bcf56e1c511a1ef539acfe11e37727e1179e)

commit 0e3cc3d042a2da1ed781f6691dd7aca72d87046b
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Mar 1 14:09:29 2016 -0500

    xv: Fix unchecked AddResource
    
    Reviewed-by: Julien Cristau <jcristau@debian.org>
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 093f9505c12565cc19bdf6e33b263f31d104c3ef)

commit 3d7bfe02cc3ad0f16403a073f1182d7019c98be3
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Mar 1 17:03:44 2016 +0100

    vidmode: build without xf86vidmodeproto
    
    git commit f175cf45:
    
      vidmode: move to a separate library of its own
    
    introduced a regression where the xserver would not build when
    xf86vidmodeproto is not installed even if the configure option
    "--disable-xf86vidmode" is specified.
    
    Fix build failure when xf86vidmodeproto is not installed.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit ac4d8c7cee13947b688ebb26035f06f7744db201)

commit a49e7b9c2ebeb2e2ccb922265798234a8ce9d242
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Feb 8 17:48:26 2016 +0100

    xwayland: fix a crash on output removal
    
    On output removal, the CRTC that was added in xwl_output_create()
    is not removed in xwl_output_destroy() and would cause a segmentation
    fault later on in ProcRRGetMonitors():
    
      (EE) Segmentation fault at address 0x100000001
      (EE)
      (EE) 10: ? (?+0x29) [0x29]
      (EE) 9: /usr/bin/Xwayland (_start+0x29) [0x423299]
      (EE) 8: /lib64/libc.so.6 (__libc_start_main+0xf0) [0x7fdd80e7f580]
      (EE) 7: /usr/bin/Xwayland (dix_main+0x3b3) [0x544ef3]
      (EE) 6: /usr/bin/Xwayland (Dispatch+0x31e) [0x54109e]
      (EE) 5: /usr/bin/Xwayland (ProcRRGetMonitors+0x9b) [0x4ca18b]
      (EE) 4: /usr/bin/Xwayland (RRMonitorMakeList+0x269) [0x4c9ba9]
      (EE) 3: /usr/bin/Xwayland (RRMonitorSetFromServer+0x118) [0x4c9198]
      (EE) 2: /usr/bin/Xwayland (MakeAtom+0x30) [0x530710]
      (EE) 1: /lib64/libc.so.6 (__restore_rt+0x0) [0x7fdd80e93b1f]
      (EE) 0: /usr/bin/Xwayland (OsSigHandler+0x29) [0x5792d9]
    
    Remove the output CRTC in xwl_output_destroy() to avoid the crash.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Daniel Stone <daniels@collabora.com>
    (cherry picked from commit 2116f03be04240e961649ca750a7aa5438b8446c)

commit c7735f102aa9daa604f304f2e8a2131fcdd652e8
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 18 17:33:19 2016 +0900

    present: Call present_restore_screen_pixmap from present_set_abort_flip
    
    After present_set_abort_flip, the screen pixmap will be used for all
    screen drawing, so we need to restore the current flip pixmap contents
    to the screen pixmap here as well.
    
    Improves flashing / stutter e.g. when something like a popup menu appears
    on top of a flipping fullscreen window or when switching out of
    fullscreen.
    
    Note that this means present_set_abort_flip now relies on screen->root
    being non-NULL, but that's already the case in other present code.
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>
    (cherry picked from commit 1bee4e254ca0305cb23e574b4c8b250d276ee998)

commit 05d9de4e9ac515176f41f9fd649935ae990d8fb3
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 18 17:20:45 2016 +0900

    present: Factor code for restoring screen pixmap out of present_unflip (v2)
    
    The following fix will use the refactored function.
    
    The logic in the refactored function is slightly simplified, exploiting
    the fact that this function is only ever called with a valid flip
    pixmap.
    
    v2: Assert that flip_pixmap is non-NULL instead of testing and bailing
        on NULL, preserve test for flip_window being non-NULL before calling
        present_set_tree_pixmap for it (Keith Packard)
    
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk> (v1)
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 4611e902c291b8a789f374cff3300f74645bc2b2)

commit 49b2a0fb0e6ae0793171b5dbfe517fe06647c06d
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Thu Feb 18 18:23:47 2016 +0900

    present: Only update screen pixmap from flip pixmap once per unflip
    
    present_unflip may be called several times from present_check_flip_window
    during the same unflip. We can only copy to the screen pixmap the first
    time, otherwise we may scribble over other windows. The flip pixmap
    contents don't get updated after the first time anyway.
    
    Fixes at least the following problems, which were introduced by commit
    806470b9 ("present: Copy unflip contents back to the Screen Pixmap"):
    
    On xfwm4 without compositing, run glxgears and put its window into
    fullscreen mode to start flipping. While in fullscreen, open the xfwm4
    window menu by pressing Alt-Space. The window menu was invisible most
    of the time because it was getting scribbled over by a repeated unflip
    copy.
    
    When switching a flipping window out of fullscreen, a repeated unflip
    copy could leave artifacts of the flip pixmap on the desktop.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94325
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>
    (cherry picked from commit 72328e5eb98a3f27e1f0a0e17beae6db447bd87c)

commit d5b8bc69e2652d8b9b13065b6528d2e8b8188b57
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Dec 8 12:52:17 2015 +0900

    dri3: Refuse to work for remote clients (v2)
    
    Prevents clients forwarded via SSH from hanging while waiting for the
    reply from the DRI3Open request.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93261
    
    v2: Return BadMatch instead of BadRequest (Keith Packard)
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 43eb5b6047c9b35c337e553ec054f08bdc835abb)

commit 15454c5d26b00931b2099ccc6da356a1e5b6f88c
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Feb 10 09:35:39 2016 +0100

    xwayland: add partial xvidmode extension support
    
    Older games (mostly those based on SDL 1.x) rely on the XVidMode
    extension and would refuse to run without.
    
    Add a simple, limited and read-only xvidmode support that reports the
    current mode used so that games that rely on xvidmode extension can run
    on XWayland.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=87806
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 6070a749d953951bacbfb149c5c36451293aad35)

commit f2b346f9ba86ba304baac5ed29f8caf3fefbdba0
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:25 2016 +0100

    vidmode: remove redundant DIX function
    
    The API signature of the DIX xf86VidModeGetGammaRampSize() is now
    identical to the xf86cmap's xf86GetGammaRampSize() and all it does is
    actually call xf86GetGammaRampSize() so we can save one vfunc.
    
    Remove uneeded xf86VidModeGetGammaRampSize() function.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit b430f53bb753f9b064ab62d014820c1c3c76a841)

commit d381d59e44f675d01ca9ecab5a58c4864ae56c29
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:24 2016 +0100

    vidmode: remove redundant check
    
    The DIX already checks for VidModePrivateKey to get the vfunc, so
    checking for this again in the DDX is redundant.
    
    Remove the redundant function xf86VidModeAvailable() from the DDX.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 48fccde2bfb60efdbf45a96fa53bcd9a6570bf89)

commit 349b71a37e4a87e3650b5c0df9651b2ce967293e
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Feb 10 09:34:34 2016 +0100

    vidmode: move to a separate library of its own
    
    XVidMode extension might be useful to non hardware servers as well (e.g.
    Xwayand) so that applications that rely on it (e.g. lot of older games)
    can at least have read access to XVidMode.
    
    But the implementation is very XFree86 centric, so the idea is to add
    a bunch of vfunc that other non-XFree86 servers can hook up into to
    provide a similar functionality.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=87806
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit f175cf45aebcdda53f3ae49c0eaf27da1f194e92)

commit 860669b1867178fe46df9da98591ea5a47f427f1
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:22 2016 +0100

    vidmode: rename DDX functions
    
    To avoid confusion as to what belongs on the DDX and what not.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 17097e083b2392c8989474f6e0da8cc234329e9c)

commit 64053645cfd950bb0b6c3fda8deb60e1e540ce69
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:21 2016 +0100

    vidmode: move display mode definitions
    
    To be able to reuse the VidMode extension in a non-hardware server, the
    display mode definitions need to be accessible from DIX.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit ddfb8c009ac651209eb0087aaf86b54e1446e8b2)

commit 227b533bf414e03e9a73d0d9e47a761fc597c360
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:20 2016 +0100

    vidmode: remove mode access from public API
    
    The mode access functions (namely VidModeCreateMode(),
    VidModeCopyMode(), VidModeGetModeValue() and VidModeSetModeValue()) are
    used only in xf86VidMode code and do not need to be available anywhere
    else.
    
    Remove these functions from the public VidMode API and move them as
    static where they are used.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit e29a64de662112b8ebcd3f20c89df0e8c51890ef)

commit 9824faaa58efe55a372d7dd0f6c5cbf84e77af61
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:19 2016 +0100

    vidmode: use appropriate DisplayModePtr type
    
    The API uses an untyped pointer (void *) where a DisplayModePtr is
    expected.
    
    Clean up the API to use the appropriate type, as DisplayModePtr is
    really all that will be passed there.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit b7962ade5265a21ac7c60da6cc07ece15ef7e648)

commit 3b52aee6dddc2cd2780f729e9389a1515c544c61
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:18 2016 +0100

    vidmode: remove VidModeGetMonitor()
    
    VidModeGetMonitor() is used solely in ProcXF86VidModeGetMonitor() to
    get a untyped monitor pointer that is passed back straight again to
    VidModeGetMonitorValue().
    
    This is actually useless as VidModeGetMonitorValue() could as well get
    the monitor from the ScreenPtr just like VidModeGetMonitor() does.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 12f714fd95dc9d912c0bf2524005a73ec6e8ee4f)

commit b241fd6413775f76a5faaea0f685a8294322e2fc
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:17 2016 +0100

    vidmode: use ScreenPtr instead of screen index
    
    New code passes ScreenPtr instead of the screen index.
    
    Change the VidMode functions to take a ScreenPtr.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit f6f7e21133c13c34f306a191137d566e83b40929)

commit 2028b9066ddbbeaf585e154d19c2672cccdda9bb
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:16 2016 +0100

    vidmode: get rid of the CloseScreen wrapper
    
    As we rely on dixRegisterPrivateKey() to allocate the memory for us that
    will be free automatically, we do not need the CloseScreen wrapper
    anymore.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 6e898ef080df93e885ead9d6fee8854b34e0216f)

commit cb3a8768db1b7b2f98f62e3075aa0dd2a46edd9d
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 09:48:15 2016 +0100

    vidmode: use appropriate API
    
    dixRegisterPrivateKey() can allocate memory that will be freed when the
    screen is teared down.
    
    No need to calloc() and free the memory ourself using a broken ref
    counting method.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 341f3bccafde71754a9ed2303df9908e509c6d31)

commit 45d17e6bb0ee35662913cd6ce378460aa7e461cc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 12 11:59:53 2016 +0000

    dri2: Allow many blocked clients per-drawable
    
    This patch was motivated by the need to fix the use-after-free in
    dri2ClientWake, but in doing so removes an arbitrary restriction that
    limits DRI2 to only blocking the first client on each drawable. In order
    to fix the use-after-free, we need to avoid touching our privates in the
    ClientSleep callback and so we want to only use that external list as
    our means of controlling sleeps and wakeups. We thus have a list of
    sleeping clients at our disposal and can manage multiple events and
    sources.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    (cherry picked from commit d8882954570aba656d5a7be7d357feaba21cb099)

commit 204e85786f24c1ab734ab9ee015efbb790dee130
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 12 11:59:52 2016 +0000

    dix: Add ClientSignalAll()
    
    This is a variant of ClientSignal() that signals all clients with an
    optional matching sleeping client, function and closure.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    (cherry picked from commit bc3634010c096dffd1935c0c6cf8ba37534ae3d8)

commit c06a4b4a2422e937eda36a4ec10bdafc71001be7
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Tue Aug 11 15:45:57 2015 +0100

    xwin: Add SKIPTASKBAR hint to _NET_WM_WINDOW_TYPE_DOCK type windows
    
    Signed-off-by: Jon Turney <jon.turney@dronecode.org.uk>
    Reviewed-by: Colin Harrison <colin.harrison@virgin.net>
    (cherry picked from commit f7d1e5acdf5ed4ab4ed5c18727aa6f3d379ef560)

commit 6f099c7bd59039834c7b45289310b003b81cb3e3
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Thu Jul 2 19:21:11 2015 +0100

    xwin: In multiwindow mode, look up the HWND for the parent window
    
    Rather than only looking at the foreground window to see if it matches
    the WM_TRANSIENT_FOR window XID, lookup that XID and fetch the HWND from
    the window privates.
    
    Signed-off-by: Jon Turney <jon.turney@dronecode.org.uk>
    Reviewed-by: Colin Harrison <colin.harrison@virgin.net>
    (cherry picked from commit e7f87f8f76e5ac9479a71e3daf2cfdefd4b5f684)

commit 41cbb7da4e9337d4136d378f5fa45365f41f02e4
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Mon Feb 22 17:41:14 2016 +0000

    xwin: Keyboard layout updates
    
    layout zh_TW doesn't exist (anymore), try something else for that.
    
    layout it variant mac doesn't seem to exist anymore, try to handle
    Macintosh keyboards (running under Parallels on Mac) and other oddities
    in a more generic way, by falling back to matching only on the language
    identifer part of the input locale identifer.
    
    v2:
    Fix typo of 0xa0000 for 0xa000
    
    Signed-off-by: Jon Turney <jon.turney@dronecode.org.uk>
    Reviewed-by: Colin Harrison <colin.harrison@virgin.net>
    (cherry picked from commit 8c2006ddc5abbd4ac374dabf1cfdd3df8fc88779)

commit da7745065ee27d62cc2eba4e860118459917dad9
Author: Colin Harrison <colin.harrison@virgin.net>
Date:   Wed Nov 19 22:33:39 2014 +0000

    xwin: Add a tentative entry for the Korean keyboard to the list of known keyboard layouts
    
    Signed-off-by: Colin Harrison <colin.harrison@virgin.net>
    Reviewed-by: Jon Turney <jon.turney@dronecode.org.uk>
    (cherry picked from commit 8c97a0078e7fe22e6159fa53490dfca2f4d267a9)

commit c1eb12f89c2391cd99a834da6b342f104da1eb5c
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Tue Feb 10 14:36:37 2015 +0000

    xwin: Update to XRANDR 1.2 internal interface to ensure an output is reported by XRANDR
    
    If using the X server internal XRANDR 1.0 interface, it seems we must
    register a display size with RRRegisterSize() in order to make
    RRGetInfo() call RRScanOldConfig() to generate an output and crtc for
    us.
    
    Without this, the following GDM bug means that an XDMCP session to GDM
    cannot be started.
    
    https://bugzilla.gnome.org/show_bug.cgi?id=736054
    
    Instead, use the more recent XRANDR 1.2 internal interface to explicitly
    create the output and crtc, and maintain a single mode which represents
    the current display size.
    
    Also don't emit a RRScreenSizeNotify when a RRScreenSizeSize is done
    which has no effect, this seems to throw the GDM greeter into a loop...
    
    v2: Maintain reference count for the mode we maintain more correctly, to
    avoid double free causing a crash on shutdown
    
    Connect crtc to output, so a subsequent RRSetCrtcConfig request doesn't
    change anything, so we don't fail due to our lack of rrSetConfig or
    rrCrtcSet hooks.
    
    See https://cygwin.com/ml/cygwin-xfree/2015-02/msg00032.html
    
    v3:
    Raise limit on X display size from 4Kx4K to 32Kx32K
    
